using System;
using System.Collections; 
using System.Text; 
using System.IO;
 

namespace sampa
{
	public class Sentence
	{
		Word[] wordsObj;
		int length;

		int type;
		public string mbrolaStr;

		enum SentenceType:int
		{
			Affirmative,Question,Exclamatory
		}

		public Sentence(string sentence)
		{
			type=GetType(sentence);
			sentence= sentence.Remove(sentence.Length-1 ,1);//removes . ? ! 
			string [] words=sentence.Trim(' ').Split();
			wordsObj= new Word[words.Length]; 
			length=wordsObj.Length;  
			Fill(words); 
			setSentenceAcc(); 
			mbrolaStr= Write();
			ToMbrola(mbrolaStr);
		}
		
		int GetType(string sent)
		{
			string sign= sent.Substring(sent.Length-1 ,1);
			switch(sign)
			{
				case("."):
					return this.type=(int)SentenceType.Affirmative;  
					
				case("?"):
					return this.type=(int)SentenceType.Question;
				
				case("!"):
				
					return this.type=(int)SentenceType.Exclamatory;
					
				default:
					return this.type=(int)SentenceType.Affirmative;			
			}
		}
		
		public void ToMbrola(string s)
		{
			char [] mb= s.ToCharArray(); 
			Stream st=new FileStream("mbrola.pho", FileMode.Create);
			BinaryWriter bw = new BinaryWriter(st);
			bw.Write(mb);
			st.Close(); 
		}
		string Write()
		{
			string s = "_ 100 \n";
			for(int i=0;i<wordsObj.Length;i++)
			{
				s+=wordsObj[i].Write(); 
			}
			s += "_ 150";
			return s;
		}
		void Fill(string[] sentence)
		{
			for(int i=0;i<sentence.Length;i++)
			{
				wordsObj[i]=  new Word(sentence[i].Trim(' ')); 
				wordsObj[i].SetAccent();
  
				Console.WriteLine(sentence[i]+" " ); 
			}
		}

		void setSentenceAcc()
		{
			if(type==(int)SentenceType.Affirmative)
			{
				if(length>2)
				{
					wordsObj[length-2].ChangeF0(-40); 
				}
				wordsObj[length-1].ChangeF0(-40);  
			}
			else if(type==(int)SentenceType.Question)
			{
				if(length>2)
				{
					wordsObj[0].ChangeF0(50);
					wordsObj[length-1].ChangeLinearyF0(50); 
				}else
					wordsObj[0].ChangeF0(50);                    
			}
			else if(type==(int)SentenceType.Exclamatory) 
			{
				wordsObj[0].ChangeF0(70);
				int step = 40/length-1;
				int val = 40;
				for(int i=1;i<length-1;i++)
				{
					wordsObj[i].ChangeF0(val);
					val -= step;
				}
			}
		}


	}
}
